Home | History | Annotate | Line # | Download | only in dist
makedefs revision 1.1.1.6
      1      1.1  tron #!/bin/sh
      2      1.1  tron 
      3      1.1  tron #++
      4      1.1  tron # NAME
      5      1.1  tron #	makedefs 1
      6      1.1  tron # SUMMARY
      7      1.1  tron #	makefile configuration utility
      8      1.1  tron # SYNOPSIS
      9      1.1  tron #	\fBmake makefiles \fIname=value...\fR
     10      1.1  tron # DESCRIPTION
     11      1.1  tron #	The \fBmakedefs\fR command identifies the compilation
     12      1.1  tron #	environment, and emits macro definitions on the standard output
     13      1.1  tron #	stream that can be prepended to template Makefiles.
     14      1.1  tron #
     15      1.1  tron #	Default settings can be overruled by specifying them as
     16      1.1  tron #	environment variables. Use quotes if variables contain
     17      1.1  tron #	whitespace or shell meta characters.
     18      1.1  tron # .IP \fBAUXLIBS=\fIobject_library...\fR
     19      1.1  tron #	Specifies one or more non-default object libraries.
     20      1.1  tron # .IP \fBCC=\fIcompiler_command\fR
     21      1.1  tron #	Specifies a non-default compiler. On many systems, the default
     22      1.1  tron #	is \fBgcc\fR.
     23      1.1  tron # .IP \fBCCARGS=\fIcompiler_arguments\fR
     24      1.1  tron #	Specifies non-default compiler arguments, for example, a non-default
     25      1.1  tron #	\fIinclude\fR directory.
     26      1.1  tron #	The following directives are special:
     27      1.1  tron # .RS
     28      1.1  tron # .IP \fB-DNO_DEVPOLL\fR
     29      1.1  tron #	Do not build with Solaris /dev/poll support.
     30      1.1  tron #	By default, /dev/poll support is compiled in on platforms that
     31      1.1  tron #	are known to support it.
     32      1.1  tron # .IP \fB-DNO_EPOLL\fR
     33      1.1  tron #	Do not build with Linux EPOLL support.
     34      1.1  tron #	By default, EPOLL support is compiled in on platforms that
     35      1.1  tron #	are known to support it.
     36      1.1  tron # .IP \fB-DNO_IPV6\fR
     37      1.1  tron #	Do not build with IPv6 support.
     38      1.1  tron #	By default, IPv6 support is compiled in on platforms that
     39      1.1  tron #	are known to have IPv6 support.
     40      1.1  tron #
     41      1.1  tron #	Note: this directive is for debugging and testing only. It
     42      1.1  tron #	is not guaranteed to work on all platforms.
     43      1.1  tron # .IP \fB-DNO_KQUEUE\fR
     44      1.1  tron #	Do not build with FreeBSD/NetBSD/OpenBSD/MacOSX KQUEUE support.
     45      1.1  tron #	By default, KQUEUE support is compiled in on platforms that
     46      1.1  tron #	are known to support it.
     47      1.1  tron # .IP \fB-DNO_PCRE\fR
     48      1.1  tron #	Do not build with PCRE support.
     49      1.1  tron #	By default, PCRE support is compiled in when the \fBpcre-config\fR
     50      1.1  tron #	utility is installed.
     51      1.1  tron # .IP \fB-DNO_SIGSETJMP\fR
     52      1.1  tron #	Use setjmp()/longjmp() instead of sigsetjmp()/siglongjmp().
     53      1.1  tron #	By default, Postfix uses sigsetjmp()/siglongjmp() when they
     54      1.1  tron #	appear to work.
     55      1.1  tron # .RE
     56      1.1  tron # .IP \fBDEBUG=\fIdebug_level\fR
     57      1.1  tron #	Specifies a non-default debugging level. The default is \fB-g\fR.
     58      1.1  tron #	Specify \fBDEBUG=\fR to turn off debugging.
     59      1.1  tron # .IP \fBOPT=\fIoptimization_level\fR
     60      1.1  tron #	Specifies a non-default optimization level. The default is \fB-O\fR.
     61      1.1  tron #	Specify \fBOPT=\fR to turn off optimization.
     62      1.1  tron # .IP \fBWARN=\fIwarning_flags\fR
     63      1.1  tron #	Specifies non-default gcc compiler warning options for use when
     64      1.1  tron #	"make" is invoked in a source subdirectory only.
     65      1.1  tron # LICENSE
     66      1.1  tron # .ad
     67      1.1  tron # .fi
     68      1.1  tron #	The Secure Mailer license must be distributed with this software.
     69      1.1  tron # AUTHOR(S)
     70      1.1  tron #	Wietse Venema
     71      1.1  tron #	IBM T.J. Watson Research
     72      1.1  tron #	P.O. Box 704
     73      1.1  tron #	Yorktown Heights, NY 10598, USA
     74      1.1  tron #--
     75      1.1  tron 
     76      1.1  tron # Emit system-dependent Makefile macro definitions to standard output.
     77      1.1  tron 
     78      1.1  tron # Defaults for most sane systems
     79      1.1  tron 
     80      1.1  tron RANLIB=ranlib
     81      1.1  tron SYSLIBS=
     82      1.1  tron AR=ar
     83      1.1  tron ARFL=rv
     84      1.1  tron 
     85      1.1  tron # Ugly function to make our error message more visible among the
     86      1.1  tron # garbage that is output by some versions of make(1).
     87      1.1  tron 
     88      1.1  tron # By now all shells must have functions.
     89      1.1  tron 
     90      1.1  tron error() {
     91      1.1  tron    # Alas, tput(1) is not portable so we can't use visual effects.
     92      1.1  tron    echo "ATTENTION:" 1>&2;
     93      1.1  tron    echo "ATTENTION:" $* 1>&2;
     94      1.1  tron    echo "ATTENTION:" 1>&2;
     95      1.1  tron    exit 1
     96      1.1  tron }
     97      1.1  tron 
     98      1.1  tron case $# in
     99      1.1  tron  # Officially supported usage.
    100      1.1  tron  0) SYSTEM=`(uname -s) 2>/dev/null`
    101      1.1  tron     RELEASE=`(uname -r) 2>/dev/null`
    102      1.1  tron     VERSION=`(uname -v) 2>/dev/null`
    103      1.1  tron     case "$VERSION" in
    104      1.1  tron      dcosx*) SYSTEM=$VERSION;;
    105      1.1  tron     esac;;
    106      1.1  tron  # Unsupported debug-only mode. Not suitable for cross-platform tests.
    107      1.1  tron  2) SYSTEM="$1"; RELEASE="$2";;
    108      1.1  tron  *) echo usage: $0 [system release] 1>&2; exit 1;;
    109      1.1  tron esac
    110      1.1  tron 
    111      1.1  tron case "$SYSTEM.$RELEASE" in
    112      1.1  tron    SCO_SV.3.2)	SYSTYPE=SCO5
    113      1.1  tron 		# Use the native compiler by default
    114      1.1  tron 		: ${CC="/usr/bin/cc -b elf"}
    115      1.1  tron 		CCARGS="$CCARGS -DPIPES_CANT_FIONREAD $CCARGS"
    116      1.1  tron 		SYSLIBS="-lsocket -ldbm"
    117      1.1  tron 		RANLIB=echo
    118      1.1  tron 		;;
    119      1.1  tron   UnixWare.5*)	SYSTYPE=UW7
    120      1.1  tron 		# Use the native compiler by default
    121      1.1  tron 		: ${CC=/usr/bin/cc}
    122      1.1  tron 		RANLIB=echo
    123      1.1  tron 		SYSLIBS="-lresolv -lsocket -lnsl"
    124      1.1  tron 		;;
    125      1.1  tron   UNIX_SV.4.2*)	case "`uname -v`" in
    126      1.1  tron 	      2.1*) SYSTYPE=UW21
    127      1.1  tron 		    # Use the native compiler by default
    128      1.1  tron 		    : ${CC=/usr/bin/cc}
    129      1.1  tron 		    RANLIB=echo
    130      1.1  tron 		    SYSLIBS="-lresolv -lsocket -lnsl -lc -L/usr/ucblib -lucb"
    131      1.1  tron 		    ;;
    132      1.1  tron 	      *) error "Seems to be UnixWare`uname -v`. Untested.";;
    133      1.1  tron 		esac
    134      1.1  tron 		;;
    135      1.1  tron   FreeBSD.2*)	SYSTYPE=FREEBSD2
    136      1.1  tron 		;;
    137      1.1  tron   FreeBSD.3*)	SYSTYPE=FREEBSD3
    138      1.1  tron 		;;
    139      1.1  tron   FreeBSD.4*)	SYSTYPE=FREEBSD4
    140      1.1  tron 		;;
    141      1.1  tron   FreeBSD.5*)	SYSTYPE=FREEBSD5
    142      1.1  tron 		;;
    143      1.1  tron   FreeBSD.6*)	SYSTYPE=FREEBSD6
    144      1.1  tron 		;;
    145      1.1  tron   FreeBSD.7*)	SYSTYPE=FREEBSD7
    146      1.1  tron 		;;
    147  1.1.1.2  tron   FreeBSD.8*)	SYSTYPE=FREEBSD8
    148  1.1.1.2  tron 		;;
    149      1.1  tron   OpenBSD.2*)	SYSTYPE=OPENBSD2
    150      1.1  tron 		;;
    151      1.1  tron   OpenBSD.3*)	SYSTYPE=OPENBSD3
    152      1.1  tron 		;;
    153      1.1  tron   OpenBSD.4*)	SYSTYPE=OPENBSD4
    154      1.1  tron 		;;
    155  1.1.1.6  tron   OpenBSD.5*)	SYSTYPE=OPENBSD5
    156  1.1.1.6  tron 		;;
    157      1.1  tron   ekkoBSD.1*)	SYSTYPE=EKKOBSD1
    158      1.1  tron 		;;
    159      1.1  tron    NetBSD.1*)	SYSTYPE=NETBSD1
    160      1.1  tron 		;;
    161      1.1  tron    NetBSD.2*)	SYSTYPE=NETBSD2
    162      1.1  tron 		;;
    163      1.1  tron    NetBSD.3*)	SYSTYPE=NETBSD3
    164      1.1  tron 		;;
    165      1.1  tron    NetBSD.4*)	SYSTYPE=NETBSD4
    166      1.1  tron 		;;
    167      1.1  tron    BSD/OS.2*)	SYSTYPE=BSDI2
    168      1.1  tron 		;;
    169      1.1  tron    BSD/OS.3*)	SYSTYPE=BSDI3
    170      1.1  tron 		;;
    171      1.1  tron    BSD/OS.4*)	SYSTYPE=BSDI4
    172      1.1  tron 		;;
    173      1.1  tron  OSF1.V[3-5].*)	SYSTYPE=OSF1
    174      1.1  tron 		# Use the native compiler by default
    175      1.1  tron 		: ${CC=cc}
    176      1.1  tron 		: ${DEBUG="-g3"}
    177      1.1  tron 		case $RELEASE in
    178      1.1  tron 		V[0-4].*) CCARGS="$CCARGS -DNO_IPV6";;
    179      1.1  tron 		esac
    180      1.1  tron 		;;
    181      1.1  tron     SunOS.4*)	SYSTYPE=SUNOS4
    182      1.1  tron 		SYSLIBS=-lresolv
    183      1.1  tron 		;;
    184      1.1  tron     SunOS.5*)	SYSTYPE=SUNOS5
    185      1.1  tron 		RANLIB=echo
    186      1.1  tron 		SYSLIBS="-lresolv -lsocket -lnsl"
    187      1.1  tron 		# Stock awk breaks with >10 files.
    188      1.1  tron 		test -x /usr/xpg4/bin/awk && AWK=/usr/xpg4/bin/awk
    189      1.1  tron 		# Solaris 2.5 added usleep() and POSIX regular expressions
    190      1.1  tron 		case $RELEASE in
    191      1.1  tron 		    5.[0-4]) CCARGS="$CCARGS -DMISSING_USLEEP -DNO_POSIX_REGEXP";;
    192      1.1  tron 		esac
    193      1.1  tron 		# Solaris 8 added IPv6 and /dev/poll
    194      1.1  tron 		case $RELEASE in
    195      1.1  tron 		    5.[0-7]|5.[0-7].*) CCARGS="$CCARGS -DNO_IPV6 -DNO_DEVPOLL";;
    196      1.1  tron 		esac
    197      1.1  tron 		# Solaris 9 added closefrom(), futimesat() and /dev/*random
    198      1.1  tron 		case $RELEASE in
    199      1.1  tron 		    5.[0-8]|5.[0-8].*) CCARGS="$CCARGS -DNO_CLOSEFROM -DNO_DEV_URANDOM -DNO_FUTIMESAT";;
    200      1.1  tron 		esac
    201      1.1  tron 		# Work around broken str*casecmp(). Do it all here instead
    202      1.1  tron 		# of having half the solution in the sys_defs.h file.
    203      1.1  tron 		CCARGS="$CCARGS -Dstrcasecmp=fix_strcasecmp \
    204      1.1  tron 		    -Dstrncasecmp=fix_strncasecmp"
    205      1.1  tron 		STRCASE="strcasecmp.o"
    206      1.1  tron 		# Avoid common types of braindamage
    207      1.1  tron 		case "$LD_LIBRARY_PATH" in
    208      1.1  tron 		?*) error "Don't set LD_LIBRARY_PATH";;
    209      1.1  tron 		esac
    210      1.1  tron 		case "${CC}" in
    211      1.1  tron 		*" "*) ;;
    212      1.1  tron 		*ucb*) error "Don't use /usr/ucb/cc or ucblib";;
    213      1.1  tron 		  cc*) case `which ${CC}` in
    214      1.1  tron 		*ucb*) error "Don't use /usr/ucb/cc or ucblib";;
    215      1.1  tron 		  esac;;
    216      1.1  tron 		esac
    217      1.1  tron 		;;
    218      1.1  tron    ULTRIX.4*)	SYSTYPE=ULTRIX4
    219      1.1  tron 		if [ -f /usr/local/lib/libdb.a ]; then
    220      1.1  tron 		    SYSLIBS="$SYSLIBS -ldb"
    221      1.1  tron 		    CCARGS="$CCARGS -DHAS_DB"
    222      1.1  tron 		    if [ -d /usr/local/include/db ]; then
    223      1.1  tron 			CCARGS="$CCARGS -I/usr/local/include/db"
    224      1.1  tron 		    fi
    225      1.1  tron 		fi
    226      1.1  tron 		for l in syslog resolv; do
    227      1.1  tron 		    if [ -f /usr/local/lib/lib$l.a ]; then
    228      1.1  tron 			SYSLIBS="$SYSLIBS -l$l"
    229      1.1  tron 		    fi
    230      1.1  tron 		done
    231      1.1  tron 		;;
    232      1.1  tron        AIX.*)	case "`uname -v`" in
    233  1.1.1.4  tron 		6)	SYSTYPE=AIX6
    234  1.1.1.4  tron 			case "$CC" in
    235  1.1.1.4  tron 			cc|*/cc|xlc|*/xlc) CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
    236  1.1.1.4  tron 			esac
    237  1.1.1.4  tron 			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
    238  1.1.1.4  tron 			;;
    239      1.1  tron 		5)	SYSTYPE=AIX5
    240      1.1  tron 			case "$CC" in
    241      1.1  tron 			cc|*/cc|xlc|*/xlc) CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
    242      1.1  tron 			esac
    243      1.1  tron 			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
    244      1.1  tron 			;;
    245      1.1  tron 		4)	SYSTYPE=AIX4
    246      1.1  tron 			# How embarrassing...
    247      1.1  tron 			case "$CC" in
    248      1.1  tron 			cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
    249      1.1  tron 			esac
    250      1.1  tron 			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
    251      1.1  tron 			;;
    252      1.1  tron 		3)	SYSTYPE=AIX3
    253      1.1  tron 			# How embarrassing...
    254      1.1  tron 			case "$CC" in
    255      1.1  tron 			cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w";;
    256      1.1  tron 			esac
    257      1.1  tron 			CCARGS="$CCARGS -D_ALL_SOURCE"
    258      1.1  tron 			;;
    259      1.1  tron 		*)	error "Unknown AIX version: `uname -v`.";;
    260      1.1  tron 		esac;;
    261      1.1  tron 		# Tested with RedHat 3.03 on 20020729.
    262      1.1  tron     Linux.1*)	SYSTYPE=LINUX1
    263      1.1  tron 		SYSLIBS="-ldb"
    264      1.1  tron 		;;
    265      1.1  tron     Linux.2*)	SYSTYPE=LINUX2
    266      1.1  tron 		# Postfix no longer needs DB 1.85 compatibility
    267      1.1  tron 		if [ -f /usr/include/db.h ]
    268      1.1  tron 		then
    269      1.1  tron 		    : we are all set
    270      1.1  tron 		elif [ -f /usr/include/db/db.h ]
    271      1.1  tron 		then
    272      1.1  tron 		    CCARGS="$CCARGS -I/usr/include/db"
    273      1.1  tron 		else
    274      1.1  tron 		    # No, we're not going to try db1 db2 db3 etc.
    275      1.1  tron 		    # On a properly installed system, Postfix builds
    276      1.1  tron 		    # by including <db.h> and by linking with -ldb
    277      1.1  tron 		    echo "No <db.h> include file found." 1>&2
    278      1.1  tron 		    echo "Install the appropriate db*-devel package first." 1>&2
    279      1.1  tron 		    echo "See the RELEASE_NOTES file for more information." 1>&2
    280      1.1  tron 		    exit 1
    281      1.1  tron 		fi
    282      1.1  tron 		# GDBM locks the DBM .pag file after open. This breaks postmap.
    283      1.1  tron 		# if [ -f /usr/include/gdbm-ndbm.h ]
    284      1.1  tron 		# then
    285      1.1  tron 		#     CCARGS="$CCARGS -DHAS_DBM -DPATH_NDBM_H='<gdbm-ndbm.h>'"
    286      1.1  tron 		#     GDBM_LIBS=gdbm
    287      1.1  tron 		# elif [ -f /usr/include/gdbm/ndbm.h ]
    288      1.1  tron 		# then
    289      1.1  tron 		#     CCARGS="$CCARGS -DHAS_DBM -DPATH_NDBM_H='<gdbm/ndbm.h>'"
    290      1.1  tron 		#     GDBM_LIBS=gdbm
    291      1.1  tron 		# fi
    292      1.1  tron 		SYSLIBS="-ldb"
    293      1.1  tron 		for name in nsl resolv $GDBM_LIBS
    294      1.1  tron 		do
    295      1.1  tron 		    for lib in /usr/lib64 /lib64 /usr/lib /lib
    296      1.1  tron 		    do
    297      1.1  tron 			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
    298      1.1  tron 			    SYSLIBS="$SYSLIBS -l$name"
    299      1.1  tron 			    break
    300      1.1  tron 			}
    301      1.1  tron 		    done
    302      1.1  tron 		done
    303      1.1  tron 		# Kernel 2.4 added IPv6
    304      1.1  tron 		case "$RELEASE" in
    305      1.1  tron 		2.[0-3].*) CCARGS="$CCARGS -DNO_IPV6";;
    306      1.1  tron 		esac
    307      1.1  tron 		# Kernel 2.6 added EPOLL
    308      1.1  tron 		case "$RELEASE" in
    309      1.1  tron 		2.[0-5].*) CCARGS="$CCARGS -DNO_EPOLL";;
    310      1.1  tron 		    # Workaround for retarded libc 
    311  1.1.1.3  tron 		    2.6.*)
    312  1.1.1.3  tron 		       if [ `expr "X$CCARGS" : "X.*-DNO_EPOLL"` -gt 0 ]
    313  1.1.1.3  tron                        then
    314  1.1.1.3  tron                            :
    315  1.1.1.3  tron                        elif [ ! -e /usr/include/sys/epoll.h ]
    316  1.1.1.3  tron                        then
    317  1.1.1.3  tron                            echo CCARGS="$CCARGS -DNO_EPOLL"
    318  1.1.1.3  tron                        else
    319  1.1.1.3  tron 			   trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
    320      1.1  tron 			   cat >makedefs.test.c <<'EOF'
    321      1.1  tron #include <sys/types.h>
    322      1.1  tron #include <sys/epoll.h>
    323      1.1  tron #include <errno.h>
    324      1.1  tron #include <stdio.h>
    325      1.1  tron #include <stdlib.h>
    326      1.1  tron 
    327      1.1  tron int     main(int argc, char **argv)
    328      1.1  tron {
    329      1.1  tron     int     epoll_handle;
    330      1.1  tron 
    331      1.1  tron     if ((epoll_handle = epoll_create(1)) < 0) {
    332      1.1  tron 	perror("epoll_create");
    333      1.1  tron 	exit(1);
    334      1.1  tron     }
    335      1.1  tron     exit(0);
    336      1.1  tron }
    337      1.1  tron EOF
    338      1.1  tron 			   ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
    339      1.1  tron 			   ./makedefs.test 2>/dev/null ||
    340      1.1  tron 				CCARGS="$CCARGS -DNO_EPOLL"
    341  1.1.1.3  tron 			   rm -f makedefs.test makedefs.test.[co]
    342  1.1.1.3  tron 		       fi;;
    343      1.1  tron 		esac
    344      1.1  tron 		;;
    345  1.1.1.5  tron     Linux.3*)	SYSTYPE=LINUX3
    346  1.1.1.5  tron 		if [ -f /usr/include/db.h ]
    347  1.1.1.5  tron 		then
    348  1.1.1.5  tron 		    : we are all set
    349  1.1.1.5  tron 		elif [ -f /usr/include/db/db.h ]
    350  1.1.1.5  tron 		then
    351  1.1.1.5  tron 		    CCARGS="$CCARGS -I/usr/include/db"
    352  1.1.1.5  tron 		else
    353  1.1.1.5  tron 		    # On a properly installed system, Postfix builds
    354  1.1.1.5  tron 		    # by including <db.h> and by linking with -ldb
    355  1.1.1.5  tron 		    echo "No <db.h> include file found." 1>&2
    356  1.1.1.5  tron 		    echo "Install the appropriate db*-devel package first." 1>&2
    357  1.1.1.5  tron 		    echo "See the RELEASE_NOTES file for more information." 1>&2
    358  1.1.1.5  tron 		    exit 1
    359  1.1.1.5  tron 		fi
    360  1.1.1.5  tron 		SYSLIBS="-ldb"
    361  1.1.1.5  tron 		for name in nsl resolv
    362  1.1.1.5  tron 		do
    363  1.1.1.5  tron 		    for lib in /usr/lib64 /lib64 /usr/lib /lib
    364  1.1.1.5  tron 		    do
    365  1.1.1.5  tron 			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
    366  1.1.1.5  tron 			    SYSLIBS="$SYSLIBS -l$name"
    367  1.1.1.5  tron 			    break
    368  1.1.1.5  tron 			}
    369  1.1.1.5  tron 		    done
    370  1.1.1.5  tron 		done
    371  1.1.1.5  tron 		;;
    372      1.1  tron      GNU.0*|GNU/kFreeBSD.[567]*)
    373      1.1  tron      		SYSTYPE=GNU0
    374      1.1  tron 		# Postfix no longer needs DB 1.85 compatibility
    375      1.1  tron 		if [ -f /usr/include/db.h ]
    376      1.1  tron 		then
    377      1.1  tron 		    : we are all set
    378      1.1  tron 		elif [ -f /usr/include/db/db.h ]
    379      1.1  tron 		then
    380      1.1  tron 		    CCARGS="$CCARGS -I/usr/include/db"
    381      1.1  tron 		else
    382      1.1  tron 		    # No, we're not going to try db1 db2 db3 etc.
    383      1.1  tron 		    # On a properly installed system, Postfix builds
    384      1.1  tron 		    # by including <db.h> and by linking with -ldb
    385      1.1  tron 		    echo "No <db.h> include file found." 1>&2
    386      1.1  tron 		    echo "Install the appropriate db*-devel package first." 1>&2
    387      1.1  tron 		    echo "See the RELEASE_NOTES file for more information." 1>&2
    388      1.1  tron 		    exit 1
    389      1.1  tron 		fi
    390      1.1  tron 		SYSLIBS="-ldb"
    391      1.1  tron 		for name in nsl resolv
    392      1.1  tron 		do
    393      1.1  tron 		    for lib in /usr/lib64 /lib64 /usr/lib /lib
    394      1.1  tron 		    do
    395      1.1  tron 			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
    396      1.1  tron 			    SYSLIBS="$SYSLIBS -l$name"
    397      1.1  tron 			    break
    398      1.1  tron 			}
    399      1.1  tron 		    done
    400      1.1  tron 		done
    401      1.1  tron 		case "`uname -s`" in
    402      1.1  tron 		GNU)
    403      1.1  tron 			# currently no IPv6 support on Hurd
    404      1.1  tron 			CCARGS="$CCARGS -DNO_IPV6"
    405      1.1  tron 			;;
    406      1.1  tron 		esac
    407      1.1  tron 		;;
    408      1.1  tron      IRIX*.5.*)	SYSTYPE=IRIX5
    409      1.1  tron 		# Use the native compiler by default
    410      1.1  tron 		: ${CC=cc} ${DEBUG="-g3"}
    411      1.1  tron 		RANLIB=echo
    412      1.1  tron 		;;
    413      1.1  tron      IRIX*.6.*)	SYSTYPE=IRIX6
    414      1.1  tron 		# Use the native compiler by default, and allow nested comments.
    415      1.1  tron 		: ${CC="cc -woff 1009,1116,1412"}
    416      1.1  tron 		RANLIB=echo
    417      1.1  tron 		;;
    418      1.1  tron HP-UX.A.09.*)	SYSTYPE=HPUX9
    419      1.1  tron 		SYSLIBS=-ldbm
    420      1.1  tron 		CCARGS="$CCARGS -DMISSING_USLEEP"
    421      1.1  tron 		if [ -f /usr/lib/libdb.a ]; then
    422      1.1  tron 		    CCARGS="$CCARGS -DHAS_DB"
    423      1.1  tron 		    SYSLIBS="$SYSLIBS -ldb"
    424      1.1  tron 		fi
    425      1.1  tron 		;;
    426      1.1  tron HP-UX.B.10.*)	SYSTYPE=HPUX10
    427      1.1  tron 		CCARGS="$CCARGS `nm /usr/lib/libc.a 2>/dev/null |
    428      1.1  tron 		    (grep usleep >/dev/null || echo '-DMISSING_USLEEP')`"
    429      1.1  tron 		if [ -f /usr/lib/libdb.a ]; then
    430      1.1  tron 		    CCARGS="$CCARGS -DHAS_DB"
    431      1.1  tron 		    SYSLIBS=-ldb
    432      1.1  tron 		fi
    433      1.1  tron 		;;
    434      1.1  tron HP-UX.B.11.*)	SYSTYPE=HPUX11
    435      1.1  tron 		SYSLIBS=-lnsl
    436      1.1  tron 		if [ -f /usr/lib/libdb.a ]; then
    437      1.1  tron 		    CCARGS="$CCARGS -DHAS_DB"
    438      1.1  tron 		    SYSLIBS="$SYSLIBS -ldb"
    439      1.1  tron 		fi
    440      1.1  tron 		;;
    441      1.1  tron ReliantUNIX-?.5.43) SYSTYPE=ReliantUnix543
    442      1.1  tron 		RANLIB=echo
    443      1.1  tron 		SYSLIBS="-lresolv -lsocket -lnsl"
    444      1.1  tron 		;;
    445      1.1  tron     Darwin.*)   SYSTYPE=MACOSX
    446      1.1  tron 		# Use the native compiler by default
    447      1.1  tron 		: ${CC=cc}
    448      1.1  tron 		# Darwin > 1.3 uses awk and flat_namespace
    449      1.1  tron 		case $RELEASE in
    450      1.1  tron 		 1.[0-3]) AWK=gawk;;
    451      1.1  tron 		       *) AWK=awk
    452      1.1  tron 			  SYSLIBS=-flat_namespace;;
    453      1.1  tron 		esac
    454      1.1  tron 		# Darwin 7 adds IPv6 support, BIND_8_COMPAT, NO_NETINFO
    455      1.1  tron 		case $RELEASE in
    456      1.1  tron 		 [1-6].*) CCARGS="$CCARGS -DNO_IPV6";;
    457      1.1  tron 		       *) CCARGS="$CCARGS -DBIND_8_COMPAT -DNO_NETINFO";;
    458      1.1  tron 		esac
    459  1.1.1.3  tron 		# Darwin 10.3.0 no longer has <nameser8_compat.h>.
    460  1.1.1.3  tron 		case $RELEASE in
    461  1.1.1.3  tron 		     ?.*) CCARGS="$CCARGS -DRESOLVE_H_NEEDS_NAMESER8_COMPAT_H";;
    462  1.1.1.3  tron 		       *) CCARGS="$CCARGS -DRESOLVE_H_NEEDS_ARPA_NAMESER_COMPAT_H";;
    463  1.1.1.3  tron 		esac
    464      1.1  tron 		# kqueue and/or poll are broken up to and including MacOS X 10.5
    465      1.1  tron 		CCARGS="$CCARGS -DNO_KQUEUE"
    466      1.1  tron #		# Darwin 8.11.1 has kqueue support, but let's play safe
    467      1.1  tron #		case $RELEASE in
    468      1.1  tron #		 [1-8].*) CCARGS="$CCARGS -DNO_KQUEUE";;
    469      1.1  tron #		       *) trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
    470      1.1  tron #			  cat >makedefs.test.c <<'EOF'
    471      1.1  tron #/* Adapted from libevent. */
    472      1.1  tron #
    473      1.1  tron ##include <sys/types.h>
    474      1.1  tron ##include <sys/event.h>
    475      1.1  tron ##include <sys/time.h>
    476      1.1  tron ##include <string.h>
    477      1.1  tron ##include <stdlib.h>
    478      1.1  tron ##include <stdio.h>
    479      1.1  tron #
    480      1.1  tron ##ifndef EV_SET
    481      1.1  tron ##define EV_SET(kp, id, fi, fl, ffl, da, ud) do { \
    482      1.1  tron #	struct kevent *__kp = (kp); \
    483      1.1  tron #	__kp->ident = (id); \
    484      1.1  tron #	__kp->filter = (fi); \
    485      1.1  tron #	__kp->flags = (fl); \
    486      1.1  tron #	__kp->fflags = (ffl); \
    487      1.1  tron #	__kp->data = (da); \
    488      1.1  tron #	__kp->udata = (ud); \
    489      1.1  tron #    } while(0)
    490      1.1  tron ##endif
    491      1.1  tron #
    492      1.1  tron #int     main(int argc, char **argv)
    493      1.1  tron #{
    494      1.1  tron #    int     kq;
    495      1.1  tron #    struct kevent test_change;
    496      1.1  tron #    struct kevent test_result;
    497      1.1  tron #
    498      1.1  tron #    if ((kq = kqueue()) < 0) {
    499      1.1  tron #	perror("kqueue");
    500      1.1  tron #	exit(1);
    501      1.1  tron #    }
    502      1.1  tron ##define TEST_FD (-1)
    503      1.1  tron #
    504      1.1  tron #    EV_SET(&test_change, TEST_FD, EVFILT_READ, EV_ADD, 0, 0, 0);
    505      1.1  tron #    if (kevent(kq,
    506      1.1  tron #	       &test_change, sizeof(test_change) / sizeof(struct kevent),
    507      1.1  tron #	       &test_result, sizeof(test_result) / sizeof(struct kevent),
    508      1.1  tron #	       (struct timespec *) 0) != 1 ||
    509      1.1  tron #	test_result.ident != TEST_FD ||
    510      1.1  tron #	test_result.flags != EV_ERROR) {
    511      1.1  tron #	fprintf(stderr, "Error: kevent reports errors incorrectly\n");
    512      1.1  tron #	exit(1);
    513      1.1  tron #    }
    514      1.1  tron #    exit(0);
    515      1.1  tron #}
    516      1.1  tron #EOF
    517      1.1  tron #			  $CC -o makedefs.test makedefs.test.c || exit 1
    518      1.1  tron #			  ./makedefs.test 2>/dev/null || 
    519      1.1  tron #				CCARGS="$CCARGS -DNO_KQUEUE"
    520      1.1  tron #			  rm -f makedefs.test makedefs.test.[co];;
    521      1.1  tron #		esac
    522      1.1  tron 		;;
    523      1.1  tron     dcosx.1*)	SYSTYPE=DCOSX1
    524      1.1  tron 		RANLIB=echo
    525      1.1  tron 		SYSLIBS="-lresolv -lsocket -lnsl -lc -lrpcsvc -L/usr/ucblib -lucb"
    526      1.1  tron 		;;
    527      1.1  tron 
    528      1.1  tron 	 ".")	if [ -d /NextApps ]; then
    529      1.1  tron 		    SYSTYPE=`hostinfo | sed -n \
    530      1.1  tron 			's/^.*NeXT Mach 3.*$/NEXTSTEP3/;/NEXTSTEP3/{p;q;}'`
    531      1.1  tron 		    if [ "$SYSTYPE" = "" ]; then
    532      1.1  tron 			SYSTYPE=`hostinfo | sed -n \
    533      1.1  tron 			    's/^.*NeXT Mach 4.*$/OPENSTEP4/;/OPENSTEP4/{p;q;}'`
    534      1.1  tron 		    fi
    535      1.1  tron 		    : ${CC=cc}
    536      1.1  tron 		    RANLIB="sleep 5; ranlib"
    537      1.1  tron 		else
    538      1.1  tron 		    error "Unable to determine your system type."
    539      1.1  tron 		fi
    540      1.1  tron 		;;
    541      1.1  tron 	   *)	error "Unknown system type: $SYSTEM $RELEASE";;
    542      1.1  tron esac
    543      1.1  tron 
    544      1.1  tron #
    545      1.1  tron # sigsetjmp()/siglongjmp() can be "better" than setjmp()/longjmp()
    546      1.1  tron # if used wisely (that is: almost never, just like signals).
    547      1.1  tron # Unfortunately some implementations have been buggy in the past.
    548      1.1  tron #
    549      1.1  tron case "$CCARGS" in
    550      1.1  tron  *-DNO_SIGSETJMP*) ;;
    551      1.1  tron                 *) trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
    552      1.1  tron 		   cat >makedefs.test.c <<'EOF'
    553      1.1  tron #include <setjmp.h>
    554      1.1  tron #include <stdlib.h>
    555      1.1  tron #include <stdio.h>
    556      1.1  tron 
    557      1.1  tron static int count = 0;
    558      1.1  tron 
    559      1.1  tron int     main(int argc, char **argv)
    560      1.1  tron {
    561      1.1  tron     sigjmp_buf env;
    562      1.1  tron     int     retval;
    563      1.1  tron 
    564      1.1  tron     switch (retval = sigsetjmp(env, 1)) {
    565      1.1  tron     case 0:
    566      1.1  tron 	siglongjmp(env, 12345);
    567      1.1  tron     case 12345:
    568      1.1  tron 	break;
    569      1.1  tron     default:
    570      1.1  tron 	fprintf(stderr, "Error: siglongjmp ignores second argument\n");
    571      1.1  tron 	exit(1);
    572      1.1  tron     }
    573      1.1  tron 
    574      1.1  tron     switch (retval = sigsetjmp(env, 1)) {
    575      1.1  tron     case 0:
    576      1.1  tron 	if (count++ > 0) {
    577      1.1  tron 	    fprintf(stderr, "Error: not overriding siglongjmp(env, 0)\n");
    578      1.1  tron 	    exit(1);
    579      1.1  tron 	}
    580      1.1  tron 	siglongjmp(env, 0);
    581      1.1  tron     case 1:
    582      1.1  tron 	break;
    583      1.1  tron     default:
    584      1.1  tron 	fprintf(stderr, "Error: overriding siglongjmp(env, 0) with %d\n",
    585      1.1  tron 		retval);
    586      1.1  tron 	exit(1);
    587      1.1  tron     }
    588      1.1  tron     exit(0);
    589      1.1  tron }
    590      1.1  tron EOF
    591      1.1  tron 		   ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
    592      1.1  tron 		   ./makedefs.test 2>/dev/null ||
    593      1.1  tron 			CCARGS="$CCARGS -DNO_SIGSETJMP"
    594      1.1  tron 		   rm -f makedefs.test makedefs.test.[co]
    595      1.1  tron esac
    596      1.1  tron 
    597      1.1  tron #
    598      1.1  tron # OpenSSL has no configuration query utility, but we don't try to
    599      1.1  tron # guess. We assume includes in /usr/include/openssl and libraries in
    600      1.1  tron # /usr/lib, or in their /usr/local equivalents. If the OpenSSL files
    601      1.1  tron # are in a non-standard place, their locations need to be specified.
    602      1.1  tron #
    603      1.1  tron #case "$CCARGS" in
    604      1.1  tron # *-DUSE_TLS*)	;;
    605      1.1  tron #  *-DNO_TLS*)	;;
    606      1.1  tron #           *)	CCARGS="$CCARGS -DUSE_TLS"
    607      1.1  tron #		AUXLIBS="$AUXLIBS -lssl -lcrypto"
    608      1.1  tron #		;;
    609      1.1  tron #esac
    610      1.1  tron 
    611      1.1  tron #
    612      1.1  tron # PCRE 3.x has a pcre-config utility so we don't have to guess.
    613      1.1  tron #
    614      1.1  tron case "$CCARGS" in
    615      1.1  tron *-DHAS_PCRE*)	;;
    616      1.1  tron  *-DNO_PCRE*)	;;
    617      1.1  tron            *)	pcre_cflags=`(pcre-config --cflags) 2>/dev/null` &&
    618      1.1  tron 		    pcre_libs=`(pcre-config --libs) 2>/dev/null` && {
    619      1.1  tron 			CCARGS="$CCARGS -DHAS_PCRE $pcre_cflags"
    620      1.1  tron 			AUXLIBS="$AUXLIBS $pcre_libs"
    621      1.1  tron 		}
    622      1.1  tron 		;;
    623      1.1  tron esac
    624      1.1  tron 
    625      1.1  tron # Defaults that can be overruled (make makefiles CC=cc OPT=-O6 DEBUG=)
    626      1.1  tron # Disable optimizations by default when compiling for Purify. Disable
    627      1.1  tron # optimizations by default with gcc 2.8, until the compiler is known to
    628      1.1  tron # be OK. Those who dare can still overrule this (make makefiles OPT=-O).
    629      1.1  tron 
    630      1.1  tron case "$CC" in
    631      1.1  tron  *purify*) : ${OPT=};;
    632      1.1  tron */gcc|gcc) case `$CC -v` in
    633      1.1  tron 	   "gcc version 2.8"*) : ${OPT=};;
    634      1.1  tron 	   esac;;
    635      1.1  tron       *CC) error "Don't use CC. That's the C++ compiler";;
    636      1.1  tron         *) : ${OPT='-O'};;
    637      1.1  tron esac
    638      1.1  tron #
    639      1.1  tron # "gcc -W" 3.4.2 no longer reports functions that fail to return a
    640      1.1  tron # result.  Use "gcc -Wall -Wno-comment" instead. We'll figure out
    641      1.1  tron # later if the other -Wmumble options are really redundant. Having
    642      1.1  tron # een burned once by a compiler that lies about what warnings it
    643      1.1  tron # produces, not taking that chance again.
    644      1.1  tron 
    645      1.1  tron : ${CC='gcc $(WARN)'} ${OPT='-O'} ${DEBUG='-g'} ${AWK=awk} \
    646      1.1  tron ${WARN='-Wall -Wno-comment -Wformat -Wimplicit -Wmissing-prototypes \
    647      1.1  tron 	-Wparentheses -Wstrict-prototypes -Wswitch -Wuninitialized \
    648      1.1  tron 	-Wunused -Wno-missing-braces'}
    649      1.1  tron 
    650      1.1  tron export SYSTYPE AR ARFL RANLIB SYSLIBS CC OPT DEBUG AWK OPTS
    651      1.1  tron 
    652      1.1  tron # Snapshot only.
    653      1.1  tron #CCARGS="$CCARGS -DSNAPSHOT"
    654      1.1  tron 
    655      1.1  tron # Non-production: needs thorough testing, or major changes are still
    656      1.1  tron # needed before the code stabilizes.
    657      1.1  tron #CCARGS="$CCARGS -DNONPROD"
    658      1.1  tron 
    659      1.1  tron sed 's/  / /g' <<EOF
    660      1.1  tron SYSTYPE	= $SYSTYPE
    661      1.1  tron AR	= $AR
    662      1.1  tron ARFL	= $ARFL
    663      1.1  tron RANLIB	= $RANLIB
    664      1.1  tron SYSLIBS	= $AUXLIBS $SYSLIBS
    665      1.1  tron CC	= $CC $CCARGS
    666      1.1  tron OPT	= $OPT
    667      1.1  tron DEBUG	= $DEBUG
    668      1.1  tron AWK	= $AWK
    669      1.1  tron STRCASE = $STRCASE
    670      1.1  tron EXPORT	= AUXLIBS='$AUXLIBS' CCARGS='$CCARGS' OPT='$OPT' DEBUG='$DEBUG'
    671      1.1  tron WARN	= $WARN
    672      1.1  tron EOF
    673